package jsphome.board;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.ArrayList;

// Խñ DAO ü
public class BoardDAO {

	// DB   
	Connection conn = null;
	PreparedStatement pstmt = null;
	Statement stmt = null;
	ResultSet rs = null;

	// DB    
	String jdbc_driver = "com.mysql.cj.jdbc.Driver";
	String jdbc_url = "jdbc:mysql://127.0.0.1:3306/jsphomedb";

	// DB  ޼ҵ
	public void connect() {
		try {
			Class.forName(jdbc_driver);
			conn = DriverManager.getConnection(jdbc_url, "sch", "1234");
		} catch (ClassNotFoundException e) {
			e.printStackTrace();
		} catch (SQLException e) {
			e.printStackTrace();
		}
	}

	// DB   ޼ҵ
	public void disconnect() {
		if (rs != null) {
			try {
				rs.close();
			} catch (SQLException e) {
				e.printStackTrace();
			}
		}
		if (pstmt != null) {
			try {
				pstmt.close();
			} catch (SQLException e) {
				e.printStackTrace();
			}
		}
		if (conn != null) {
			try {
				conn.close();
			} catch (SQLException e) {
				e.printStackTrace();
			}
		}
	}

	// Խñ  ҷ ޼ҵ
	public ArrayList<Board> getBoardList() {
		connect();

		ArrayList<Board> boardList = new ArrayList<>();

		String sql = "select * from Board order by date"; // ¥   ȸ SQL

		try {
			Statement stmt = conn.createStatement();
			rs = stmt.executeQuery(sql); // SQL   ResultSet Ÿ  rs 

			while (rs.next()) { // 0° Ű ִ Ŀ ù °  ̵ؼ  
				Board board = new Board(); // board ü 
				// board ü ҷ  
				board.setBid(rs.getInt("bid"));
				board.setUid(rs.getString("uid"));
				board.setSubject(rs.getString("subject"));
				board.setContent(rs.getString("content"));
				board.setDate(rs.getDate("date"));
				board.setView(rs.getInt("view"));

				//  board ü boardList 
				boardList.add(board);
			}
		} catch (SQLException e) {
			e.printStackTrace();
		} finally {
			disconnect();
		}

		return boardList; // boardList ȯ
	}

	// Խñ 󼼺
	public Board getBoard(int bid) {
		connect();

		String sql = "select * from Board where bid="; //  Խñ ȸ sql

		try {
			stmt = conn.createStatement();
			ResultSet rs = stmt.executeQuery(sql + bid); //  Խñ   rs 

			rs.next(); // ش Խñ۷ Ŀ ̵
			Board board = new Board(); // Խñ   ü 
			// ޾ƿ  board 
			board.setBid(rs.getInt("bid"));
			board.setUid(rs.getString("uid"));
			board.setSubject(rs.getString("subject"));
			board.setContent(rs.getString("content"));

			// α   ȸ ýŰ  
			if (rs.getString("uid") != null) {
				String vsql = "update Board set view=? where bid=?";
				pstmt = conn.prepareStatement(vsql);
				pstmt.setInt(1, rs.getInt("view") + 1);
				pstmt.setInt(2, bid);
				pstmt.executeUpdate();
			}

			return board; // board ü ȯ

		} catch (SQLException e) {
			e.printStackTrace();
		} finally {
			disconnect();
		}

		return null;
	}

	// Խñ 
	public boolean insertBoard(Board board) {
		connect();

		String sql = "insert into Board values(?, ?, ?, ?, ?, ?)"; // Խñ  sql

		try {
			//  ڸ Էϱ  PreparedStatement 
			pstmt = conn.prepareStatement(sql);
			//  ? ġ  
			pstmt.setInt(1, board.getBid());
			pstmt.setString(2, board.getUid());
			pstmt.setString(3, board.getSubject());
			pstmt.setString(4, board.getContent());

			java.util.Date utilDate = new java.util.Date();
			java.sql.Date sqlDate = new java.sql.Date(utilDate.getTime());
			pstmt.setDate(5, sqlDate); //  ϰ ִ ð 
			pstmt.setInt(6, 0); // ó ȸ 0

			pstmt.executeUpdate(); // DB ݿ
			return true; // ϸ true ȯ
		} catch (SQLException e) {
			e.printStackTrace();
		} finally {
			disconnect();
		}

		return false;
	}

	// Խñ 
	public boolean updateBoard(Board board) {
		connect();

		String sql = "update Board set subject=?, content=? where bid=?"; // Խñ  SQL

		try {
			//   
			pstmt = conn.prepareStatement(sql);
			pstmt.setString(1, board.getSubject());
			pstmt.setString(2, board.getContent());
			pstmt.setInt(3, board.getBid());
			pstmt.executeUpdate(); // Խñ  DB ݿ
			return true; // ϸ true ȯ
		} catch (SQLException e) {
			e.printStackTrace();
		} finally {
			disconnect();
		}

		return false;
	}

	// Խñ 
	public boolean deleteBoard(String bid) {
		connect();
		String sql = "delete from Board where bid="; //  Խñ  sql
		try {
			Statement stmt = conn.createStatement();
			stmt.executeUpdate(sql + bid); // Խñ  db ݿ
			stmt.close();

			return true; // ϸ true ȯ
		} catch (SQLException e) {
			e.printStackTrace();
		} finally {
			disconnect();
		}

		return false;
	}

}
